define([
    'taoQtiItem/qtiCreator/widgets/states/factory',
    'taoQtiItem/qtiCreator/widgets/interactions/states/Question',
    'taoQtiItem/qtiCreator/widgets/helpers/formElement',
    'taoQtiItem/qtiCreator/editor/containerEditor',
    'tpl!CodeBlockProgrammingScore/creator/tpl/propertiesForm',
    'lodash'
], function (stateFactory, Question, formElement, containerEditor, formTpl, _) {

    var pciIctStateQuestion = stateFactory.extend(Question, function () {

        var $container = this.widget.$container,
            interaction = this.widget.element;
        interaction.getResponseDeclaration().setCorrect(["PASS"]);

    }, function () {

    });

    pciIctStateQuestion.prototype.initForm = function () {

        var _widget = this.widget,
            $form = _widget.$form,
            interaction = _widget.element,
            response = interaction.getResponseDeclaration(),
            correctVal  = parseInt(interaction.prop('correctVal')) || 'PASS';

        //render the form using the form template
        $form.html(formTpl({
            serial : response.serial,
            correctVal : correctVal
        }));

        //init form javascript
        formElement.initWidget($form);

    };

    return pciIctStateQuestion;
});
