requirejs.config({
    paths: {
        jquery: 'CodeBlockProgrammingScore/runtime/js/lib/jquery.min'
    }
});
define([
    'jquery',
    'CodeBlockProgrammingScore/runtime/js/PciManager',
    'CodeBlockProgrammingScore/runtime/js/Handler'
  ], function ($, PciManager, Handler) {

    console.log('init pci CodeBlockProgrammingScore..........');

    let pciManager = new PciManager()
    pciManager.typeIdentifier = 'CodeBlockProgrammingScore';

    let createPciObject = function (base) {
        let pciObject = pciManager.assignObject(base);
        let handler = null;
        let $cbpResponseHolder = null;

        pciObject.initialize = function (id, dom, config, assetManager) {
            base.initialize(id, dom, config, assetManager);
            $cbpResponseHolder = $(dom).find('.cbp-result-holder');
            $cbpResponseHolder.val('CURRENT ANSWER IS UNDEFINED');

            handler = new Handler(id, $(dom), config, assetManager);
            handler.main();

            //tell the rendering engine that I am ready
            base.notifyReady();
        };

        pciObject.getResponse = function () {
            pciManager.updateResponse($cbpResponseHolder.val());
            return base.getResponse();
        };
        pciObject.setSerializedState = function (state) {
            if (state && state.response) {
                $cbpResponseHolder.val(state.response.base.string);
                base.setResponse(state.response);
            }
        };
        pciObject.getSerializedState = function () {
            return {response: base.getResponse()};
        };
        pciObject.destroy = function() {
            handler.destroy();
            base.destroy();
        };

        return pciObject;
    };

    let basePciObject = pciManager.getBase();
    let pciObject = createPciObject(basePciObject);
    pciManager.register(pciObject);

  });
